﻿Public Class cVaxCallParking

    Public Sub OnIncomingCall(ByVal nSessionId As Integer, ByVal sDialNo As String, ByVal nFromPeerType As Integer, ByRef bProcessed As Boolean)

        bProcessed = False

        Dim sDialNoPrefix As String = sDialNo
        sDialNoPrefix = sDialNoPrefix.Trim()

        If (sDialNoPrefix.IndexOf("#3#") <> 0) Then
            Return
        End If

        bProcessed = True
        sDialNoPrefix = sDialNoPrefix.Replace("#3#", "")
        sDialNoPrefix = sDialNoPrefix.Trim()

        Dim nSlotId As Integer

        Try

            nSlotId = Convert.ToInt32(sDialNoPrefix)

        Catch ex As Exception

            Return

        End Try

        If (cVaxServerExCOM.m_objServerExCOM.ConnectToParkedCallSession(nSessionId, cVaxServerExCOM.VAX_CALL_CHANNEL_ZERO, nSlotId) = False) Then
            Return
        End If

        StopMusicCallPark(nSessionId)

    End Sub

    Public Sub OnCallSessionTransferBlind(ByVal nTransfererSessionId As Integer, ByVal nTransfererChannelId As Integer, ByVal sTransferer As String, ByVal sTransferee As String, ByVal sTransferTo As String, ByRef bProcessed As Boolean)

        bProcessed = False

        Dim nChannelId As Integer = cVaxServerExCOM.VAX_CALL_CHANNEL_ZERO

        If (nTransfererChannelId = cVaxServerExCOM.VAX_CALL_CHANNEL_ZERO) Then
            nChannelId = cVaxServerExCOM.VAX_CALL_CHANNEL_ONE
        End If


        Dim sPrefixedSlotId As String = sTransferTo
        sPrefixedSlotId.Trim()

        If (sPrefixedSlotId.IndexOf("#2#") <> 0) Then
            Return
        End If

        bProcessed = True

        If (Not cVaxServerExCOM.m_objServerExCOM.AcceptTransferBlind(nTransfererSessionId, "", "", "", -1, "", 30)) Then
            Return
        End If

        sPrefixedSlotId = sPrefixedSlotId.Replace("#2#", "")
        sPrefixedSlotId = sPrefixedSlotId.Trim()

        Dim nSlotId As Integer

        Try

            nSlotId = Convert.ToInt32(sPrefixedSlotId)

        Catch ex As Exception

            Return

        End Try

        If (cVaxServerExCOM.m_objServerExCOM.ParkCallSession(nTransfererSessionId, nChannelId, nSlotId) = False) Then
            Return
        End If

        StartMusicCallPark(nTransfererSessionId, nChannelId)

    End Sub

    Private Function StartMusicCallPark(ByVal nSessionId As Integer, ByVal nChannelId As Integer) As Boolean

        Dim nMusicId As Integer = cVaxServerExCOM.m_objServerExCOM.GetMusicCallParkingId()

        Return cVaxServerExCOM.m_objServerExCOM.PlayWaveStartToCallSession(nSessionId, nChannelId, nMusicId, True, 10)

    End Function

    Private Sub StopMusicCallPark(ByVal nSessionId As Integer)

        Dim nMusicId As Integer = cVaxServerExCOM.m_objServerExCOM.GetMusicCallParkingId()

        cVaxServerExCOM.m_objServerExCOM.PlayWaveStopToCallSession(nSessionId, cVaxServerCOM.VAX_CALL_CHANNEL_ZERO, nMusicId)
        cVaxServerExCOM.m_objServerExCOM.PlayWaveStopToCallSession(nSessionId, cVaxServerCOM.VAX_CALL_CHANNEL_ONE, nMusicId)

    End Sub

End Class
