﻿Public Class cVaxQueue

    Public Sub New()
    End Sub

    Public Sub OnIncomingCall(ByVal nSessionId As Integer, ByVal sCallerName As String, ByVal sCallerId As String, ByVal sQueueName As String, ByRef bProcessed As Boolean)

        bProcessed = False

        If (sQueueName.Length = 0) Then
            Return
        End If

        cVaxServerExCOM.m_objServerExCOM.AddCallSessionToQueue(sQueueName, sCallerName, sCallerId, nSessionId, 20)
        bProcessed = True

    End Sub

    Public Sub OnAddCallSessionToQueueSuccess(ByVal sQueueName As String, ByVal nSessionId As Integer)

    End Sub

    Public Sub OnAddCallSessionToQueueFailed(ByVal sQueueName As String, ByVal nSessionId As Integer)
    End Sub


    Public Sub OnQueuePlayWaveStart(ByVal nEventType As Integer, ByVal sQueueName As String, ByVal nSessionId As Integer)

        If (nEventType = cVaxServerCOM.VAX_QUEUE_PLAY_WAVE_EVENT_TYPE_MUSIC) Then

            Dim nQueueMusicId As Integer = cVaxServerExCOM.m_objServerExCOM.GetQueueMusicId(sQueueName)
            cVaxServerExCOM.m_objServerExCOM.PlayWaveStartToCallSession(nSessionId, cVaxServerExCOM.VAX_CALL_CHANNEL_ZERO, nQueueMusicId, True, 0)

            Return

        End If

        Dim nQueueDialTone As Integer = cVaxServerExCOM.m_objServerExCOM.GetQueueDialToneId(sQueueName)
        cVaxServerExCOM.m_objServerExCOM.PlayWaveStartToCallSession(nSessionId, cVaxServerExCOM.VAX_CALL_CHANNEL_ZERO, nQueueDialTone, True, 0)

    End Sub

    Public Sub OnQueuePlayWaveStop(ByVal nEventType As Integer, ByVal sQueueName As String, ByVal nSessionId As Integer)

        If (nEventType = cVaxServerCOM.VAX_QUEUE_PLAY_WAVE_EVENT_TYPE_MUSIC) Then

            Dim nQueueMusicId As Integer = cVaxServerExCOM.m_objServerExCOM.GetQueueMusicId(sQueueName)
            cVaxServerExCOM.m_objServerExCOM.PlayWaveStopToCallSession(nSessionId, cVaxServerExCOM.VAX_CALL_CHANNEL_ZERO, nQueueMusicId)

            Return

        End If

        Dim nQueueDialTone As Integer = cVaxServerExCOM.m_objServerExCOM.GetQueueDialToneId(sQueueName)
        cVaxServerExCOM.m_objServerExCOM.PlayWaveStopToCallSession(nSessionId, cVaxServerExCOM.VAX_CALL_CHANNEL_ZERO, nQueueDialTone)

    End Sub

End Class
