#pragma once
#include "afxwin.h"

class CVaxServerSIP;

// CAddConferenceDlg dialog

class CAddConferenceDlg : public CPropertyPage
{
	DECLARE_DYNAMIC(CAddConferenceDlg)

public:
	
	CAddConferenceDlg(CVaxServerSIP* pVaxTeleSIP);
	virtual ~CAddConferenceDlg();

public:

	CVaxServerSIP* m_pVaxTeleSIP;

// Dialog Data
	enum { IDD = IDD_DIALOG_ADD_CONFERENCE };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()

private:

	CComboBox m_ctrlComboRoomName;
	CString m_sRoomNo;
	CString m_sRoomName;

public:

	afx_msg void OnButtonAddRoom();
	afx_msg void OnButtonRemoveRoom();
	
	afx_msg void OnCbnSelchangeComboConferenceRoomName();

private:

	BOOL AddRoomChecks();

	void ClearDlgContent();
	void AddRooms();

	void ShowRoomDetails();

public:

	BOOL OnSetActive();
	
};
