#pragma once

class CVaxServerExCOM;

class CVaxCallSession
{

public:

	CVaxCallSession(CVaxServerExCOM* pServerExCOM);
	~CVaxCallSession();

private:
	
	CString m_sRoomName;
	CVaxServerExCOM* m_pServerExCOM;
	
private:

	BOOL AcceptCallSession(LONG lSessionId, LPCTSTR sCallerName, LPCTSTR sCallerId, LPCTSTR sDialNo, int nToPeerType, LPCTSTR sToPeerName);
	
public:

	void OnIncomingCall(LONG lSessionId, LPCTSTR sCallerName, LPCTSTR sCallerId, LPCTSTR sDialNo, CString sRoomName, LONG lFromPeerType, LPCTSTR sFromPeerName, LONG lToPeerType, LPCTSTR sToPeerName, LPCTSTR sUserAgentName, LPCTSTR sFromIP, LONG lFromPort);
	void OnCallSessionConnected(LONG lSessionId);
	
	void OnCallSessionConnecting(LONG lSessionId,  int nChannelId, LONG lStatusCode, LPCTSTR sReasonPhrase);
	void OnCallSessionFailed(LONG lSessionId, int nChannelId, LONG lStatusCode, LPCTSTR sReasonPhrase);

	void OnCallSessionOnHold(LONG lSessionId, int nChanneld);
	void OnCallSessionOffHold(LONG lSessionId, int nChanneld);

	void OnCallSessionTransferBlind(LONG lTransfererSessionId, LONG lTransfererChanneld, LPCTSTR sTransferer, LPCTSTR sTransferee, LPCTSTR sTransferTo);
	void OnCallSessionTransferConsult(LONG lTransfererSessionId, int nTransfererChanneld, LONG lTransferToSessionId, int nTransferToChanneld, LPCTSTR sTransferer, LPCTSTR sTransferee, LPCTSTR sTransferTo);

	void OnDetectedDigitDTMF(LONG lSessionId, int nChanneld, LPCTSTR sDigitDTMF);

	void OnCallSessionRecordedPCM(LONG lSessionId, int nChannelId, char* pDataPCM, DWORD dwSizePCM);
	void OnConferenceRoomRecordedPCM(LPCTSTR sRoomName, char* pDataPCM, DWORD dwSizePCM);
};

