// Codec.h: interface for the CCodec class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CODEC_H__D79693AD_70E2_48AB_AE60_1A39E633007C__INCLUDED_)
#define AFX_CODEC_H__D79693AD_70E2_48AB_AE60_1A39E633007C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#define G711U_TEXT	"G711u-Law"
#define G711A_TEXT	"G711a-Law"
#define ILBC_TEXT	"iLBC"
#define G610_TEXT	"GSM6.10"
#define G729_TEXT	"G729"

#define VAX_CODEC_GSM610_STR		"0"
#define VAX_CODEC_ILBC_STR			"1"
#define VAX_CODEC_G711A_STR			"2"
#define VAX_CODEC_G711U_STR			"3"
#define VAX_CODEC_G729_STR			"4"

#define VAX_CODEC_GSM610_CHAR		'0'
#define VAX_CODEC_ILBC_CHAR			'1'
#define VAX_CODEC_G711A_CHAR		'2'
#define VAX_CODEC_G711U_CHAR		'3'
#define VAX_CODEC_G729_CHAR			'4'

#define TOTAL_NO_CODEC				'5'

class CCodec  
{
public:
	CCodec();
	~CCodec();

public:

	CString GetCodecNo(CString sCodecText);
	CString GetCodecName(char cCodecNo);

};

#endif // !defined(AFX_CODEC_H__D79693AD_70E2_48AB_AE60_1A39E633007C__INCLUDED_)
