#pragma once

#include "ConfRoomList.h"

class CVaxServerExCOM;

class CConfRoom
{

private:

	CVaxServerExCOM* m_pServerExCOM;
	CConfRoomList* m_pConfRoomList;

public:

	CConfRoom(CVaxServerExCOM* pServerExCOM);
	~CConfRoom();

public:

	BOOL AddRoom(LPCTSTR sRoomName, LPCTSTR sRoomNo);
	void RemoveRoom(LPCTSTR sRoomName);

	CString GetRoomName(LPCTSTR sRoomNo);
	
	BOOL GetRoomDetails(LPCTSTR sRoomName, CString& sRoomNo);
	BOOL IsRoomNoExists(LPCTSTR sRoomNo);

	BOOL GetRoomAll(CStringList* pRoomList);
	void DeleteRoomAll();
};

